import { MongooseDocument } from 'mongoose';
declare type ClassDecorator = (constructor: any) => void;
declare type HookNextFn = (err?: Error) => void;
declare type PreDoneFn = () => void;
declare type TypegooseDoc<T> = T & MongooseDocument;
declare type DocumentPreSerialFn<T> = (this: TypegooseDoc<T>, next: HookNextFn) => void;
declare type DocumentPreParallelFn<T> = (this: TypegooseDoc<T>, next: HookNextFn, done: PreDoneFn) => void;
declare type SimplePreSerialFn<T> = (next: HookNextFn, docs?: any[]) => void;
declare type SimplePreParallelFn<T> = (next: HookNextFn, done: PreDoneFn) => void;
declare type ModelPostFn<T> = (result: any, next?: HookNextFn) => void;
declare type PostNumberResponse<T> = (result: number, next?: HookNextFn) => void;
declare type PostSingleResponse<T> = (result: TypegooseDoc<T>, next?: HookNextFn) => void;
declare type PostMultipleResponse<T> = (result: TypegooseDoc<T>[], next?: HookNextFn) => void;
declare type PostNumberWithError<T> = (error: Error, result: number, next: HookNextFn) => void;
declare type PostSingleWithError<T> = (error: Error, result: TypegooseDoc<T>, next: HookNextFn) => void;
declare type PostMultipleWithError<T> = (error: Error, result: TypegooseDoc<T>[], next: HookNextFn) => void;
export declare const pre: {
    <T>(method: RegExp | "init" | "validate" | "save" | "remove", fn: DocumentPreSerialFn<T>): ClassDecorator;
    <T>(method: RegExp | "init" | "validate" | "save" | "remove", parallel: boolean, fn: DocumentPreParallelFn<T>): ClassDecorator;
    <T>(method: RegExp | "count" | "find" | "findOne" | "findOneAndRemove" | "findOneAndUpdate" | "update" | "updateOne" | "updateMany" | "insertMany", fn: SimplePreSerialFn<T>): ClassDecorator;
    <T>(method: RegExp | "count" | "find" | "findOne" | "findOneAndRemove" | "findOneAndUpdate" | "update" | "updateOne" | "updateMany" | "insertMany", parallel: boolean, fn: SimplePreParallelFn<T>): ClassDecorator;
};
export declare const post: {
    <T>(method: RegExp | "count", fn: PostNumberResponse<T>): ClassDecorator;
    <T>(method: RegExp | "count", fn: PostNumberWithError<T>): ClassDecorator;
    <T>(method: RegExp | "init" | "validate" | "save" | "remove" | "findOne" | "findOneAndRemove" | "findOneAndUpdate", fn: PostSingleResponse<T>): ClassDecorator;
    <T>(method: RegExp | "init" | "validate" | "save" | "remove" | "findOne" | "findOneAndRemove" | "findOneAndUpdate", fn: PostSingleWithError<T>): ClassDecorator;
    <T>(method: RegExp | "find" | "update", fn: PostMultipleResponse<T>): ClassDecorator;
    <T>(method: RegExp | "find" | "update", fn: PostMultipleWithError<T>): ClassDecorator;
    <T>(method: RegExp | "insertMany", fn: ModelPostFn<T> | PostMultipleResponse<T>): ClassDecorator;
};
export {};
